function imageshackUpload(el)
{
	var myTabRef;
	var tabsMode;

	// get image URL
	var url = el.getAttribute("url");
	// close context menu
	document.getElementById("contentAreaContextMenu").hidePopup();

	// load extension preferences
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefBranch);
	if (prefs.getPrefType("extensions.imageshack.loadLocation") == prefs.PREF_INT)
	{
		tabsMode = prefs.getIntPref("extensions.imageshack.loadLocation");
	}
	else
	{
		// Pref wasn't found so let's set a default
		prefs.setIntPref("extensions.imageshack.loadLocation", 3);
		tabsMode = 3;
	}

	// open the new tab/window etc
	switch(tabsMode)
	{
		case 0:
			// same tab
			myTabRef = getBrowser().selectedTab;
			var tabBr = getBrowser().getBrowserForTab(myTabRef);
			var doc = tabBr.contentDocument;
  		break;    
		case 1:
			// new foreground tab
			myTabRef = getBrowser().addTab();
			getBrowser().selectedTab = myTabRef;
			var tabBr = getBrowser().getBrowserForTab(myTabRef);
			var doc = tabBr.contentDocument;
		break;  
		case 2:
			// new window
			window.open();
			var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
        			.getService(Components.interfaces.nsIWindowMediator);
			var doc = wm.getMostRecentWindow("navigator:browser").getBrowser().contentDocument;
		break;  
		case 3:
			// new background tab
			myTabRef = getBrowser().addTab();
			var tabBr = getBrowser().getBrowserForTab(myTabRef);
			var doc = tabBr.contentDocument;
		break;
		default: throw new Error("ImageShack right click: Invalid mode set!"); return;
	}

	/* Removed the form creation in favor of something simpler */
	doc.location.href = "http://www.imageshack.us/transload.php?url=" + encodeURIComponent(url);
}

function imageshackSettingsRightClick(aEvent)
{
	document.getElementById("contentAreaContextMenu").hidePopup();
	if(aEvent.button == 1)
	{
		window.openDialog("chrome://imageshack/content/imageshackSettings.xul", "imageshackextOptions", "dialog, chrome, modal, centerscreen");
	}
}
